<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) 2.1.18                                                  |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2016 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | Contentteller is not free software. You may not redistribute this file   |
// | or its derivatives without written permission.                           |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Patch #1                                                                 |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Knowledgebase
 * @copyright (C) 2002-2016 Esselbach Internet Solutions
 */

/**
 * function KnowledgebaseEntry
 * A function to show a knowledgebase entry
 * @author Philipp Louis Esselbach
 */
function KnowledgebaseEntry( $page )
{
	global $config, $database, $templates, $system, $security, $preferences, $user, $ipaddr, $uwrapper;
	list( $page_query, $opt ) = $system -> getpages( $page, 0 );
	$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_knowledgebase SET knowledgebase_views = knowledgebase_views + 1, knowledgebase_activity = now() WHERE knowledgebase_seo = '" . $page_query . "' AND (knowledgebase_website = '0' OR knowledgebase_website = '" . intval( $config[ 'WEBSITE' ] ) . "')" );
	$templates -> initgzip();

	$knowledgebase_theme = $preferences[ 'current_theme' ];
	if ( $preferences[ 'knowledgebase_template_sets' ] or $preferences[ 'knowledgebase_blocks' ] )
	{
		$query = $database -> dbquery( "SELECT knowledgebase_templateset, knowledgebase_blocks FROM " . DB_PREFIX . "esselbach_ct_knowledgebase WHERE knowledgebase_seo = '" . $page_query . "' AND (knowledgebase_website = '0' OR knowledgebase_website = '" . intval( $config[ 'WEBSITE' ] ) . "')" );
		if ( $database -> dbrows( $query ) )
		{
			list( $knowledgebase_templateset, $knowledgebase_blocks ) = $database -> dbrow( $query );
			if ( $knowledgebase_templateset )
			{
				$knowledgebase_theme = $knowledgebase_templateset;
			}
			if ( $knowledgebase_blocks )
			{
				$preferences[ 'site_blocks_override' ] = $knowledgebase_blocks;
			}
		}
	}

	$main_templates = $templates -> preparetemplates( "'site_header','site_footer','site_menu_header','site_menu_item_header','site_menu_sub_item_header','site_menu_sub_item_footer','site_menu_item_footer','site_menu_item_admin','site_menu_footer','site_header_alt','site_footer_alt','site_advertisement_header','site_advertisement_list','site_advertisement_footer','site_block','site_block_alt1','site_block_alt2','site_login_anon','site_login_user','site_login_cookie','site_invalid_form','site_social','knowledgebase_header','knowledgebase_entry_header','knowledgebase_teaserimage','knowledgebase_entry','knowledgebase_entry_password','knowledgebase_entry_editlink','knowledgebase_entry_advertisement','knowledgebase_tags','knowledgebase_tags_list','knowledgebase_lightbox_header','knowledgebase_lightbox_image','knowledgebase_lightbox_footer','knowledgebase_entry_nav','knowledgebase_entry_nav_previous','knowledgebase_entry_nav_next','knowledgebase_social','knowledgebase_facebook','knowledgebase_twitter','knowledgebase_google','knowledgebase_rating_1star','knowledgebase_rating_2stars','knowledgebase_rating_3stars','knowledgebase_rating_4stars','knowledgebase_rating_5stars','knowledgebase_error_na','knowledgebase_entry_rating_form','knowledgebase_entry_comment_scripts_standard','knowledgebase_entry_comment_scripts_wysiwyg','knowledgebase_entry_comment_pagenav_header','knowledgebase_entry_comment_pagenav_first','knowledgebase_entry_comment_pagenav_previous','knowledgebase_entry_comment_pagenav_link','knowledgebase_entry_comment_pagenav_selected','knowledgebase_entry_comment_pagenav_next','knowledgebase_entry_comment_pagenav_last','knowledgebase_entry_comment_pagenav_footer','knowledgebase_entry_comment_manage_header','knowledgebase_entry_comment','knowledgebase_entry_plonked','knowledgebase_entry_comment_userposts','knowledgebase_entry_comment_userregdate','knowledgebase_entry_comment_userlocation','knowledgebase_entry_comment_usertitle','knowledgebase_entry_comment_usertitle_anon','knowledgebase_entry_comment_usertitle_admin','knowledgebase_entry_comment_usertitle_moderator','knowledgebase_entry_comment_usertitle_subscriber','knowledgebase_entry_comment_usertitle_banned','knowledgebase_entry_comment_avatar','knowledgebase_entry_comment_signature','knowledgebase_entry_comment_profile','knowledgebase_entry_comment_messageicon','knowledgebase_entry_comment_options','knowledgebase_entry_comment_options_edit','knowledgebase_entry_comment_options_admin','knowledgebase_entry_comment_manage_footer','knowledgebase_entry_comment_form','knowledgebase_entry_comment_form_wysiwyg','knowledgebase_entry_comment_form_anon','knowledgebase_entry_comment_form_securitycode','knowledgebase_entry_comment_form_recaptcha','knowledgebase_entry_comment_form_icon','knowledgebase_entry_comment_form_iconrow','knowledgebase_entry_comment_form_signature','knowledgebase_entry_comment_form_external','knowledgebase_entry_footer','knowledgebase_footer','knowledgebase_error_noentry','knowledgebase_error_password','knowledgebase_layout_entry'", $knowledgebase_theme );
	$insert = $system -> getinsert( $preferences, $main_templates );
	$insert[ 'site_theme' ] = $knowledgebase_theme;

	if( !isset( $_POST[ 'input_security_hash' ] ) )
	{
	    $insert[ 'knowledgebase_security_hash' ] = $system -> dorand();
	    if( !$user[ 'user_nocookie' ] )
	    {
    		session_start();
    		$_SESSION[ 'knowledgebase_security_hash' ] = $insert[ 'knowledgebase_security_hash' ];
	    }
	}
	else
	{
		$insert[ 'knowledgebase_security_hash' ] = $security -> checkvar( $_POST[ 'input_security_hash' ] );
	}


	if( $user[ 'user_status' ] == 1 )
	{
		$knowledgebase_status = "(knowledgebase_status = '0' OR knowledgebase_status = '1' OR knowledgebase_status = '3')";
		$knowledgebase_status_alt = "(knowledgebase_status = '0' OR knowledgebase_status = '1')";
	}
	elseif( $user[ 'user_status' ] == 2 or $user[ 'user_status' ] == 3 )
	{
		$knowledgebase_status = "(knowledgebase_status = '0' OR knowledgebase_status = '1' OR knowledgebase_status = '2' OR knowledgebase_status = '3' OR knowledgebase_status = '4')";
		$knowledgebase_status_alt = "(knowledgebase_status = '0' OR knowledgebase_status = '1' OR knowledgebase_status = '2' OR knowledgebase_status = '4')";
	}
	elseif( $user[ 'user_status' ] == 6 )
	{
		$knowledgebase_status = "(knowledgebase_status = '0' OR knowledgebase_status = '1' OR knowledgebase_status = '3' OR knowledgebase_status = '4')";
		$knowledgebase_status_alt = "(knowledgebase_status = '0' OR knowledgebase_status = '1' OR knowledgebase_status = '4')";
	}
	else
	{
		$knowledgebase_status = "(knowledgebase_status = '0' OR knowledgebase_status = '3')";
		$knowledgebase_status_alt = "knowledgebase_status = '0'";
	}

	$query = $database -> dbquery( "SELECT knowledgebase_id, knowledgebase_author, knowledgebase_category, knowledgebase_question, knowledgebase_seo, knowledgebase_answer, knowledgebase_description, knowledgebase_keywords, knowledgebase_tags, knowledgebase_comments, knowledgebase_thread, knowledgebase_allowcomments, knowledgebase_status, knowledgebase_password, knowledgebase_date, knowledgebase_fields, knowledgebase_views, knowledgebase_rating, knowledgebase_votes FROM " . DB_PREFIX . "esselbach_ct_knowledgebase WHERE knowledgebase_seo = '" . $page_query . "' AND " . $knowledgebase_status . " AND (knowledgebase_website = '0' OR knowledgebase_website = '" . intval( $config[ 'WEBSITE' ] ) . "')" );

	if( $database -> dbrows( $query ) )
	{
		list( $insert[ 'knowledgebase_id' ], $insert[ 'knowledgebase_author' ], $insert[ 'knowledgebase_category' ], $insert[ 'knowledgebase_question' ], $insert[ 'knowledgebase_seo' ], $insert[ 'knowledgebase_answer' ], $insert[ 'knowledgebase_description' ], $insert[ 'knowledgebase_keywords' ], $insert[ 'knowledgebase_tags' ], $insert[ 'knowledgebase_comments' ], $insert[ 'knowledgebase_thread' ], $insert[ 'knowledgebase_allowcomments' ], $insert[ 'knowledgebase_status' ], $insert[ 'knowledgebase_password' ], $insert[ 'knowledgebase_date' ], $insert[ 'knowledgebase_fields' ], $insert[ 'knowledgebase_views' ], $insert[ 'knowledgebase_rating' ], $insert[ 'knowledgebase_votes' ] ) = $database -> dbrow( $query );

		if( $insert[ 'knowledgebase_status' ] == 3 )
		{
			$knowledgebase_password = ( isset( $_POST[ 'knowledgebase_password' ] ) ) ? $security -> checkvare( $_POST[ 'knowledgebase_password' ] ) : "" ;
			$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;

			if( !$knowledgebase_password )
			{
				$knowledgebase_notice = $templates -> exectemplate( $main_templates[ 'knowledgebase_password_html' ], $main_templates[ 'knowledgebase_password_php' ], $insert );
			}
			elseif( $knowledgebase_password != $insert[ 'knowledgebase_password' ] )
			{
				$knowledgebase_notice = $templates -> exectemplate( $main_templates[ 'knowledgebase_error_password_html' ], $main_templates[ 'knowledgebase_error_password_php' ], $insert );
			}
			elseif( !$user[ 'user_nocookie' ] )
			{
				session_start();

				if( $_SESSION[ 'knowledgebase_security_hash' ] != $input_security_hash )
				{
					echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
					echo $templates -> exectemplate( $main_templates[ 'site_invalid_form_html' ], $main_templates[ 'site_invalid_form_php' ], $insert );
					echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
					exit;
				}
			}
		}

		$id = $security -> checknum( $insert[ 'knowledgebase_id' ] );

		if( $preferences[ 'knowledgebase_allow_rating' ] and $insert[ 'knowledgebase_votes' ] )
		{
			if( $insert[ 'knowledgebase_rating' ] == 5 )
			{
				$insert[ 'knowledgebase_rating_line' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_rating_5stars_html' ], $main_templates[ 'knowledgebase_rating_5stars_php' ], $insert );
			}
			elseif( $insert[ 'knowledgebase_rating' ] == 4 )
			{
				$insert[ 'knowledgebase_rating_line' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_rating_4stars_html' ], $main_templates[ 'knowledgebase_rating_4stars_php' ], $insert );
			}
			elseif( $insert[ 'knowledgebase_rating' ] == 3 )
			{
				$insert[ 'knowledgebase_rating_line' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_rating_3stars_html' ], $main_templates[ 'knowledgebase_rating_3stars_php' ], $insert );
			}
			elseif( $insert[ 'knowledgebase_rating' ] == 2 )
			{
				$insert[ 'knowledgebase_rating_line' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_rating_2stars_html' ], $main_templates[ 'knowledgebase_rating_2stars_php' ], $insert );
			}
			elseif( $insert[ 'knowledgebase_rating' ] < 2 )
			{
				$insert[ 'knowledgebase_rating_line' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_rating_1star_html' ], $main_templates[ 'knowledgebase_rating_1star_php' ], $insert );
			}
		}
		else
		{
			$insert[ 'knowledgebase_rating_line' ] = "";
		}

		if( $user[ 'user_status' ] == 2 and $insert[ 'knowledgebase_author' ] == $user[ 'user_name' ] )
		{
			$insert[ 'knowledgebase_edit' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_editlink_html' ], $main_templates[ 'knowledgebase_entry_editlink_php' ], $insert );
		}
		else
		{
			$insert[ 'knowledgebase_edit' ] = "";
		}

		if( $insert[ 'knowledgebase_tags' ] )
		{
			$tags = explode( ",", $insert[ 'knowledgebase_tags' ] );
			$tags_array = array();

			foreach( $tags as $tag )
			{
				if( $tag )
				{
					$insert[ 'knowledgebase_tag' ] = ltrim( rtrim( $tag ) );
					$insert[ 'knowledgebase_tag_seo' ] = $system -> doseo( $insert[ 'knowledgebase_tag' ] );
					$tags_array[ ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_tags_list_html' ], $main_templates[ 'knowledgebase_tags_list_php' ], $insert );
				}
			}

			$insert[ 'knowledgebase_tags_list' ] = implode( ",", $tags_array );
			$insert[ 'knowledgebase_tags' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_tags_html' ], $main_templates[ 'knowledgebase_tags_php' ], $insert );
		}

		$knowledgebase_question = $insert[ 'knowledgebase_question' ];
		$insert[ 'knowledgebase_question' ] = htmlspecialchars( $insert[ 'knowledgebase_question' ], ENT_QUOTES, CT_ENCODING );
		$insert[ 'knowledgebase_author' ] = htmlspecialchars( $insert[ 'knowledgebase_author' ], ENT_QUOTES, CT_ENCODING );
		$insert[ 'knowledgebase_date' ] = $system -> convertdate( $insert[ 'knowledgebase_date' ], $preferences[ 'knowledgebase_dateformat' ], $preferences[ 'website_timezone' ] );

		if( $insert[ 'knowledgebase_fields' ] )
		{
			$input_fields_array = explode( "|", $insert[ 'knowledgebase_fields' ] );
			$extra = 0;

			for( $i = 0; $i < 24; $i++ )
			{
				$extra++;
				$insert[ 'knowledgebase_extra' . $extra ] = $system -> decode( $input_fields_array[ $i ] );
			}
		}
		else
		{
			for( $i = 1; $i < 25; $i++ )
			{
				$insert[ 'knowledgebase_extra' . $i ] = "";
			}
		}

		if( $preferences[ 'knowledgebase_image_lightbox' ] )
		{
			$insert[ 'knowledgebase_lightbox' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_lightbox_header_html' ], $main_templates[ 'knowledgebase_lightbox_header_php' ], $insert );

			$query = $database -> dbquery( "SELECT knowledgebasefile_id, knowledgebasefile_title FROM " . DB_PREFIX . "esselbach_ct_knowledgebasefiles WHERE knowledgebasefile_entry = '" . $insert[ 'knowledgebase_id' ] . "' AND (knowledgebasefile_mime LIKE 'image%') ORDER BY knowledgebasefile_id" );
			while( list( $insert[ 'knowledgebasefile_id' ], $insert[ 'knowledgebasefile_title' ] ) = $database -> dbrow( $query ) )
			{
				$insert[ 'knowledgebase_lightbox' ] .= $templates -> exectemplate( $main_templates[ 'knowledgebase_lightbox_image_html' ], $main_templates[ 'knowledgebase_lightbox_image_php' ], $insert );
			}
			$insert[ 'knowledgebase_lightbox' ] .= $templates -> exectemplate( $main_templates[ 'knowledgebase_lightbox_footer_html' ], $main_templates[ 'knowledgebase_lightbox_footer_php' ], $insert );
		}

		if( $preferences[ 'website_advertisement_middle' ] )
		{
			$insert[ 'advertisement_middle' ] = $preferences[ 'website_advertisement_middle' ];
			$insert[ 'knowledgebase_advertisement' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_advertisement_html' ], $main_templates[ 'knowledgebase_entry_advertisement_php' ], $insert );
		}
		else
		{
			$insert[ 'knowledgebase_advertisement' ] = "";
		}

		$insert[ 'knowledgebase_question_encoded' ] = urlencode( htmlspecialchars( $insert[ 'knowledgebase_question' ], ENT_QUOTES, CT_ENCODING ) );
		$insert[ 'knowledgebase_url_encoded' ] = urlencode( $system -> rewritelink( htmlspecialchars( $insert[ 'site_url' ] . "/index.php" . $insert[ 'param_ct' ] . "knowledgebase" . $insert[ 'param_action' ] . "entry" . $insert[ 'param_page' ] . $insert[ 'knowledgebase_seo' ] . ".html", ENT_QUOTES, CT_ENCODING ) ) );

		if( $preferences[ 'knowledgebase_social' ] )
		{
			$insert[ 'knowledgebase_social_links' ] = "";
			$query = $database -> dbquery( "SELECT sociallink_name, sociallink_image, sociallink_link FROM ".DB_PREFIX."esselbach_ct_sociallinks WHERE sociallink_active = '1' ORDER BY sociallink_position" );

			if ($database -> dbrows( $query ) )
			{
				while( list( $sociallink_name, $sociallink_image, $sociallink_link ) = $database -> dbrow( $query ) )
				{
					$insert[ 'sociallink_name'] = $sociallink_name;
					$insert[ 'sociallink_image'] = "images/social/" . $sociallink_image;
					$insert[ 'sociallink_link'] = str_replace( array( "URL_ENCODED", "TITLE_ENCODED" ) , array( $insert[ 'knowledgebase_url_encoded' ], $insert[ 'knowledgebase_question_encoded' ] ), $sociallink_link );
					$insert[ 'knowledgebase_social_links' ] .= $templates -> exectemplate( $main_templates[ 'site_social_html' ], $main_templates[ 'site_social_php' ], $insert );
				}
			}
			$insert[ 'knowledgebase_social' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_social_html' ], $main_templates[ 'knowledgebase_social_php' ], $insert );
		}
		else
		{
			$insert[ 'knowledgebase_social' ] = "";
		}

		if( $preferences[ 'knowledgebase_facebook' ] )
		{
			$insert[ 'knowledgebase_facebook' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_facebook_html' ], $main_templates[ 'knowledgebase_facebook_php' ], $insert );
		}
		else
		{
			$insert[ 'knowledgebase_facebook' ] = "";
		}

		if( $preferences[ 'knowledgebase_twitter' ] )
		{
			$insert[ 'knowledgebase_twitter' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_twitter_html' ], $main_templates[ 'knowledgebase_twitter_php' ], $insert );
		}
		else
		{
			$insert[ 'knowledgebase_twitter' ] = "";
		}

		if( $preferences[ 'knowledgebase_google' ] )
		{
			$insert[ 'knowledgebase_google' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_google_html' ], $main_templates[ 'knowledgebase_google_php' ], $insert );
		}
		else
		{
			$insert[ 'knowledgebase_google' ] = "";
		}

		if( $preferences[ 'knowledgebase_forum_comments' ] and $insert[ 'knowledgebase_thread' ] )
		{
			$insert[ 'knowledgebase_comments' ] = $uwrapper -> getcomment( $insert[ 'knowledgebase_thread' ] );
		}

		if ( $preferences[ 'knowledgebase_comments_wysiwyg' ] )
		{
			$insert[ 'knowledgebase_comment_scripts' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_scripts_wysiwyg_html' ], $main_templates[ 'knowledgebase_entry_comment_scripts_wysiwyg_php' ], $insert );
		}
		else
		{
			$insert[ 'knowledgebase_comment_scripts' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_scripts_standard_html' ], $main_templates[ 'knowledgebase_entry_comment_scripts_standard_php' ], $insert );
		}

		$knowledgebase_entry = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_html' ], $main_templates[ 'knowledgebase_entry_php' ], $insert );
		$input_author = $database -> dbescape( $user[ 'user_username' ] );
		$insert[ 'page_name' ] = $insert[ 'knowledgebase_question' ];
		$insert[ 'page_description' ] = htmlspecialchars( $insert[ 'knowledgebase_description' ], ENT_QUOTES, CT_ENCODING );
		$insert[ 'page_keywords' ] = htmlspecialchars( $insert[ 'knowledgebase_keywords' ], ENT_QUOTES, CT_ENCODING );
		$insert[ 'knowledgebase_entry_advertisement' ] = "";

		if( $preferences[ 'knowledgebase_pages_advertisement' ] )
		{
			$keywords_array = explode( ", ", $insert[ 'knowledgebase_keywords' ] );
			$keywords_sql_array = array();

			foreach( $keywords_array as $keyword )
			{
				$keywords_sql_array[ ] = "advertisement_keywords LIKE '%" . $database -> dbescape( $keyword ) . "%'";
			}

			$keywords_sql = implode( " OR ", $keywords_sql_array );

			if( $keywords_sql )
			{
				$keywords_sql = " WHERE (" . $keywords_sql . ") AND";
			}

			$preferences[ 'knowledgebase_max_pages_adv' ] = intval( $preferences[ 'knowledgebase_max_pages_adv' ] );

			if( !$preferences[ 'knowledgebase_max_pages_adv' ] )
			{
				$preferences[ 'knowledgebase_max_pages_adv' ] = 5;
			}

			$query = $database -> dbquery( "SELECT advertisement_id, advertisement_key, advertisement_name, advertisement_text FROM " . DB_PREFIX . "esselbach_ct_advertisements" . $keywords_sql . " advertisement_impressions > '0' AND (advertisement_website = '0' OR advertisement_website = '" . intval( $config[ 'WEBSITE' ] ) . "') ORDER BY advertisement_position LIMIT " . $preferences[ 'knowledgebase_max_pages_adv' ] );

			if( $database -> dbrows( $query ) )
			{
				$insert[ 'knowledgebase_entry_advertisement' ] .= $templates -> exectemplate( $main_templates[ 'site_advertisement_header_html' ], $main_templates[ 'site_advertisement_header_php' ], $insert );

				while( list( $advertisement_id, $advertisement_key, $advertisement_name, $advertisement_text ) = $database -> dbrow( $query ) )
				{
					$insert[ 'advertisement_key' ] = htmlspecialchars( $advertisement_key, ENT_QUOTES, CT_ENCODING );
					$insert[ 'advertisement_name' ] = htmlspecialchars( $advertisement_name, ENT_QUOTES, CT_ENCODING );
					$insert[ 'advertisement_text' ] = htmlspecialchars( $advertisement_text, ENT_QUOTES, CT_ENCODING );
					$insert[ 'knowledgebase_entry_advertisement' ] .= $templates -> exectemplate( $main_templates[ 'site_advertisement_list_html' ], $main_templates[ 'site_advertisement_list_php' ], $insert );
					$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_advertisements SET advertisement_impressions = advertisement_impressions - 1, advertisement_views = advertisement_views + 1, advertisement_activity = now() WHERE advertisement_id = '" . $advertisement_id . "'" );
				}

				$insert[ 'knowledgebase_entry_advertisement' ] .= $templates -> exectemplate( $main_templates[ 'site_advertisement_footer_html' ], $main_templates[ 'site_advertisement_footer_php' ], $insert );
			}
		}
	}

	if( ( !isset( $knowledgebase_entry ) ) or( isset( $knowledgebase_notice ) ) )
	{
		$knowledgebase_entry = "";
		$insert[ 'page_name' ] = htmlspecialchars( $preferences[ 'website_name' ], ENT_QUOTES, CT_ENCODING );
		$insert[ 'page_description' ] = htmlspecialchars( $preferences[ 'website_description' ], ENT_QUOTES, CT_ENCODING );
		$insert[ 'page_keywords' ] = htmlspecialchars( $preferences[ 'website_keywords' ], ENT_QUOTES, CT_ENCODING );
	}

	if( $preferences[ 'knowledgebase_alt_site_header' ] )
	{
		echo $templates -> exectemplate( $main_templates[ 'site_header_alt_html' ], $main_templates[ 'site_header_alt_php' ], $insert );
	}
	else
	{
		echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
	}

	if( $preferences[ 'knowledgebase_navigation' ] )
	{
		if( $knowledgebase_entry )
		{
			$insert[ 'knowledgebase_entry_header' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_header_html' ], $main_templates[ 'knowledgebase_entry_header_php' ], $insert );
		}
		else
		{
			echo $templates -> exectemplate( $main_templates[ 'knowledgebase_header_html' ], $main_templates[ 'knowledgebase_header_php' ], $insert );
		}
	}

	if( $knowledgebase_entry )
	{
		$insert[ 'knowledgebase_entry' ] = $knowledgebase_entry;
		$insert[ 'knowledgebase_entry_rating_form' ] = "";

		if( $preferences[ 'knowledgebase_allow_rating' ] )
		{
			if( $preferences[ 'knowledgebase_allow_unregrating' ] or $user[ 'user_status' ] )
			{
				$votes = 0;

				if( $user[ 'user_status' ] )
				{
					$query = $database -> dbquery( "SELECT knowledgebaserating_id FROM " . DB_PREFIX . "esselbach_ct_knowledgebaseratings WHERE knowledgebaserating_entry = '" . $id . "' and knowledgebaserating_user = '" . intval( $user[ 'user_id' ] ) . "'" );
					$votes = $database -> dbrows( $query );
				}
				else
				{
					$uniqueid = md5( $_SERVER[ 'HTTP_USER_AGENT' ] . $ipaddr );
					$query = $database -> dbquery( "SELECT knowledgebaserating_id FROM " . DB_PREFIX . "esselbach_ct_knowledgebaseratings WHERE knowledgebaserating_entry = '" . $id . "' and knowledgebaserating_uniqueid = '" . $uniqueid . "'" );
					$votes = $database -> dbrows( $query );
				}

				if( !$votes )
				{
					$insert[ 'knowledgebase_entry_rating_form' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_rating_form_html' ], $main_templates[ 'knowledgebase_entry_rating_form_php' ], $insert );
				}
			}
		}

		if( $preferences[ 'knowledgebase_navigation' ] )
		{
		    $website_url_array = array();
		    $query = $database -> dbquery( "SELECT preference_website, preference_value FROM " . DB_PREFIX . "esselbach_ct_preferences WHERE preference_key = 'WEBSITE_URL' ORDER BY preference_website" );
		    while( list( $website_id, $website_url ) = $database -> dbrow( $query ) )
		    {
		        if( !count( $website_url_array ) )
		        {
		            $website_url_array[ 0 ] = $website_url;
		        }
		        $website_url_array[ $website_id ] = $website_url;
		    }

			$query = $database -> dbquery( "SELECT knowledgebase_website, knowledgebase_question, knowledgebase_seo FROM " . DB_PREFIX . "esselbach_ct_knowledgebase WHERE knowledgebase_id < '" . $id . "' AND " . $knowledgebase_status_alt . " AND (knowledgebase_website = '0' OR knowledgebase_website = '" . intval( $config[ 'WEBSITE' ] ) . "') ORDER BY knowledgebase_id DESC LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				list( $previous_website, $previous_question, $previous_seo ) = $database -> dbrow( $query );
				$insert[ 'knowledgebase_nav_website' ] = ( $_SERVER[ 'SERVER_PORT' ] == "443" ) ? str_replace( "http://", "https://", $website_url_array[ $previous_website ] ) : $website_url_array[ $previous_website ] ;
				$insert[ 'knowledgebase_nav_seo' ] = $previous_seo;
				$insert[ 'knowledgebase_nav_question' ] = htmlspecialchars( $previous_question, ENT_QUOTES, CT_ENCODING );
				$insert[ 'knowledgebase_previous_entry' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_nav_previous_html' ], $main_templates[ 'knowledgebase_entry_nav_previous_php' ], $insert );
			}
			else
			{
				$insert[ 'knowledgebase_previous_entry' ] = "";
			}

			$query = $database -> dbquery( "SELECT knowledgebase_website, knowledgebase_question, knowledgebase_seo FROM " . DB_PREFIX . "esselbach_ct_knowledgebase WHERE knowledgebase_id > '" . $id . "' AND " . $knowledgebase_status_alt . " AND (knowledgebase_website = '0' OR knowledgebase_website = '" . intval( $config[ 'WEBSITE' ] ) . "') ORDER BY knowledgebase_id LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				list( $next_website, $next_question, $next_seo ) = $database -> dbrow( $query );
				$insert[ 'knowledgebase_nav_website' ] = ( $_SERVER[ 'SERVER_PORT' ] == "443" ) ? str_replace( "http://", "https://", $website_url_array[ $next_website ] ) : $website_url_array[ $next_website ] ;
				$insert[ 'knowledgebase_nav_seo' ] = $next_seo;
				$insert[ 'knowledgebase_nav_question' ] = htmlspecialchars( $next_question, ENT_QUOTES, CT_ENCODING );
				$insert[ 'knowledgebase_next_entry' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_nav_next_html' ], $main_templates[ 'knowledgebase_entry_nav_next_php' ], $insert );
			}
			else
			{
				$insert[ 'knowledgebase_next_entry' ] = "";
			}

			$insert[ 'knowledgebase_current_entry' ] = $insert[ 'knowledgebase_question' ];
			$insert[ 'knowledgebase_entry_nav' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_nav_html' ], $main_templates[ 'knowledgebase_entry_nav_php' ], $insert );
		}

		$insert[ 'knowledgebase_entry_comment_pagenav' ] = "";
		$insert[ 'knowledgebase_entry_comment_manage_header' ] = "";
		$insert[ 'knowledgebase_entry_comment' ] = "";
		$insert[ 'knowledgebase_entry_comment_manage_footer' ] = "";

		if( $preferences[ 'knowledgebase_forum_comments' ] and $insert[ 'knowledgebase_thread' ] )
		{
			$knowledgebase_all_comments = $insert[ 'knowledgebase_comments' ];
			$knowledgebase_user_array = $uwrapper -> getcommentsusers( $insert[ 'knowledgebase_thread' ] );
		}
		else
		{
			if( $user[ 'user_status' ] == 2 or $user[ 'user_status' ] == 3 )
			{
				$knowledgebasecomment_status = "knowledgebasecomment_entry = '" . $id . "'";
			}
			elseif( $user[ 'user_status' ] == 4 )
			{
				$knowledgebasecomment_status = "knowledgebasecomment_entry = '" . $id . "' AND (knowledgebasecomment_plonk = '" . intval( $user[ 'user_id' ] ) . "' OR knowledgebasecomment_plonk = '0')";
			}
			else
			{
				$knowledgebasecomment_status = "knowledgebasecomment_entry = '" . $id . "' AND knowledgebasecomment_plonk = '0'";
			}

			$query = $database -> dbquery( "SELECT knowledgebasecomment_authorid FROM " . DB_PREFIX . "esselbach_ct_knowledgebasecomments WHERE " . $knowledgebasecomment_status );
			$knowledgebase_all_comments = $database -> dbrows( $query );
		}

		if( $knowledgebase_all_comments )
		{
			$knowledgebase_profile_array = array();
			$knowledgebase_usertitle_question_array = array();
			$knowledgebase_usertitle_posts_array = array();
			$knowledgebase_comments_pages = ceil( $knowledgebase_all_comments / $preferences[ 'knowledgebase_max_comments' ] );

			if( !isset( $knowledgebase_user_array ) )
			{
				$knowledgebase_user_array = array();

				while( list( $knowledgebase_user_id ) = $database -> dbrow( $query ) )
				{
					$knowledgebase_user_array[ ] = "'" . intval( $knowledgebase_user_id ) . "'";
				}
			}

			$knowledgebase_profile_array = $uwrapper -> getprofilesfromarray( $knowledgebase_user_array );

			if( $opt )
			{
				$knowledgebase_comments_dbpage = $opt - 1;
				$knowledgebase_comments_page = $knowledgebase_comments_dbpage * $preferences[ 'knowledgebase_max_comments' ];
			}
			else
			{
				$knowledgebase_comments_page = 0;
			}

			$query = $database -> dbquery( "SELECT usertitle_title, usertitle_posts FROM " . DB_PREFIX . "esselbach_ct_userstitles ORDER BY usertitle_posts" );

			while( list( $usertitle_title, $usertitle_posts ) = $database -> dbrow( $query ) )
			{
				$knowledgebase_usertitle_question_array[ ] = $usertitle_title;
				$knowledgebase_usertitle_posts_array[ ] = $usertitle_posts;
			}

			if( $preferences[ 'knowledgebase_allow_msgicons' ] )
			{
				$knowledgebase_messageicons = array();
				$query = $database -> dbquery( "SELECT messageicon_id, messageicon_image FROM " . DB_PREFIX . "esselbach_ct_messageicons" );

				while( list( $messageicon_id, $messageicon_image ) = $database -> dbrow( $query ) )
				{
					$knowledgebase_messageicons[ $messageicon_id ] = $messageicon_image;
				}
			}

			if( $preferences[ 'knowledgebase_forum_comments' ] and $insert[ 'knowledgebase_thread' ] )
			{
				$knowledgebase_comments = $uwrapper -> getcommentpage( $insert[ 'knowledgebase_thread' ], $knowledgebase_comments_page, $preferences[ 'knowledgebase_max_comments' ] );
			}
			else
			{
				$query = $database -> dbquery( "SELECT knowledgebasecomment_id, knowledgebasecomment_authorid, knowledgebasecomment_author, knowledgebasecomment_icon, knowledgebasecomment_subject, knowledgebasecomment_rawtext, knowledgebasecomment_text, knowledgebasecomment_plonk, knowledgebasecomment_signature, knowledgebasecomment_smilies, knowledgebasecomment_bcode, knowledgebasecomment_date, knowledgebasecomment_edits, knowledgebasecomment_lasteditauthor, knowledgebasecomment_lasteditdate, knowledgebasecomment_postip, knowledgebasecomment_editip FROM " . DB_PREFIX . "esselbach_ct_knowledgebasecomments WHERE " . $knowledgebasecomment_status . " LIMIT " . $knowledgebase_comments_page . "," . $preferences[ 'knowledgebase_max_comments' ] );
				$knowledgebase_comments = $database -> dbrows( $query );
			}

			if( $knowledgebase_comments )
			{
				if( ( $knowledgebase_comments_page < $knowledgebase_all_comments ) and( $knowledgebase_comments_pages > 1 ) )
				{
					$insert[ 'knowledgebasecomment_totalpages' ] = $knowledgebase_comments_pages;
					$insert[ 'knowledgebase_entry_comment_pagenav' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_pagenav_header_html' ], $main_templates[ 'knowledgebase_entry_comment_pagenav_header_php' ], $insert );

					if( !$opt )
					{
						$opt = 1;
					}

					if( $knowledgebase_comments_pages > 6 )
					{
						$knowledgebase_comments_pages_new = $opt + 1;
						$knowledgebase_comments_pages_old = $opt - 1;

						if( $knowledgebase_comments_pages_new < 3 )
						{
							$knowledgebase_comments_pages_cur = 3;
						}
						else
						{
							$knowledgebase_comments_pages_cur = $knowledgebase_comments_pages_new;
						}

						if( $opt > 2 )
						{
							$insert[ 'knowledgebase_entry_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_pagenav_first_html' ], $main_templates[ 'knowledgebase_entry_comment_pagenav_first_php' ], $insert );
						}

						$current = $knowledgebase_comments_pages_cur - 2;
						$forward = $current + 4;
						$backward = $knowledgebase_comments_pages - 3;

						if( $forward > $knowledgebase_comments_pages )
						{
							$insert[ 'knowledgebasecomment_previous' ] = $insert[ 'knowledgebase_seo' ];

							if( $knowledgebase_comments_pages_old != 1 )
							{
								$insert[ 'knowledgebasecomment_previous' ] .= "," . $knowledgebase_comments_pages_old;
							}

							$insert[ 'knowledgebase_entry_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_pagenav_previous_html' ], $main_templates[ 'knowledgebase_entry_comment_pagenav_previous_php' ], $insert );

							for( $i = $backward; $i <= $knowledgebase_comments_pages; $i++ )
							{
								$insert[ 'knowledgebasecomment_page' ] = $i;

								if( $opt == $i )
								{
									$insert[ 'knowledgebase_entry_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_pagenav_selected_html' ], $main_templates[ 'knowledgebase_entry_comment_pagenav_selected_php' ], $insert );
								}
								else
								{
									$insert[ 'knowledgebasecomment_link' ] = $insert[ 'knowledgebase_seo' ];

									if( $i != 1 )
									{
										$insert[ 'knowledgebasecomment_link' ] .= "," . $i;
									}

									$insert[ 'knowledgebase_entry_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_pagenav_link_html' ], $main_templates[ 'knowledgebase_entry_comment_pagenav_link_php' ], $insert );
								}
							}
						}
						else
						{
							if( $knowledgebase_comments_pages_old > 3 )
							{
								$insert[ 'knowledgebasecomment_previous' ] = $insert[ 'knowledgebase_seo' ];

								if( $knowledgebase_comments_pages_old != 1 )
								{
									$insert[ 'knowledgebasecomment_previous' ] .= "," . $knowledgebase_comments_pages_old;
								}

								$insert[ 'knowledgebase_entry_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_pagenav_previous_html' ], $main_templates[ 'knowledgebase_entry_comment_pagenav_previous_php' ], $insert );
							}

							for( $i = $current; $i < $forward; $i++ )
							{
								$insert[ 'knowledgebasecomment_page' ] = $i;

								if( $opt == $i )
								{
									$insert[ 'knowledgebase_entry_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_pagenav_selected_html' ], $main_templates[ 'knowledgebase_entry_comment_pagenav_selected_php' ], $insert );
								}
								else
								{
									$insert[ 'knowledgebasecomment_link' ] = $insert[ 'knowledgebase_seo' ];

									if( $i != 1 )
									{
										$insert[ 'knowledgebasecomment_link' ] .= "," . $i;
									}

									$insert[ 'knowledgebase_entry_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_pagenav_link_html' ], $main_templates[ 'knowledgebase_entry_comment_pagenav_link_php' ], $insert );
								}
							}

							$insert[ 'knowledgebasecomment_next' ] = $insert[ 'knowledgebase_seo' ] . "," . $knowledgebase_comments_pages_new;
							$insert[ 'knowledgebase_entry_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_pagenav_next_html' ], $main_templates[ 'knowledgebase_entry_comment_pagenav_next_php' ], $insert );
							$insert[ 'knowledgebasecomment_last' ] = $insert[ 'knowledgebase_seo' ] . "," . $knowledgebase_comments_pages;
							$insert[ 'knowledgebase_entry_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_pagenav_last_html' ], $main_templates[ 'knowledgebase_entry_comment_pagenav_last_php' ], $insert );
						}
					}
					else
					{
						for( $i = 1; $i <= $knowledgebase_comments_pages; $i++ )
						{
							$insert[ 'knowledgebasecomment_page' ] = $i;
							$insert[ 'knowledgebasecomment_link' ] = $insert[ 'knowledgebase_seo' ];

							if( $i != 1 )
							{
								$insert[ 'knowledgebasecomment_link' ] .= "," . $i;
							}

							if( $opt == $i )
							{
								$insert[ 'knowledgebase_entry_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_pagenav_selected_html' ], $main_templates[ 'knowledgebase_entry_comment_pagenav_selected_php' ], $insert );
							}
							else
							{
								$insert[ 'knowledgebase_entry_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_pagenav_link_html' ], $main_templates[ 'knowledgebase_entry_comment_pagenav_link_php' ], $insert );
							}
						}
					}

					$insert[ 'knowledgebase_entry_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_pagenav_footer_html' ], $main_templates[ 'knowledgebase_entry_comment_pagenav_footer_php' ], $insert );
				}

				$knowledgebasecomment_id_array = array();
				$knowledgebasecomment_authorid_array = array();
				$knowledgebasecomment_author_array = array();
				$knowledgebasecomment_icon_array = array();
				$knowledgebasecomment_subject_array = array();
				$knowledgebasecomment_rawtext_array = array();
				$knowledgebasecomment_text_array = array();
				$knowledgebasecomment_plonk_array = array();
				$knowledgebasecomment_signature_array = array();
				$knowledgebasecomment_smilies_array = array();
				$knowledgebasecomment_bcode_array = array();
				$knowledgebasecomment_date_array = array();
				$knowledgebasecomment_edits_array = array();
				$knowledgebasecomment_lasteditauthor_array = array();
				$knowledgebasecomment_lasteditdate_array = array();
				$knowledgebasecomment_postip_array = array();
				$knowledgebasecomment_editip_array = array();
				$moderator = 0;

				if( $preferences[ 'knowledgebase_forum_comments' ] and $insert[ 'knowledgebase_thread' ] )
				{
					$knowledgebasecomments = $uwrapper -> getcommentspage( $insert[ 'knowledgebase_thread' ], $knowledgebase_comments_page, $preferences[ 'knowledgebase_max_comments' ] );

					foreach( $knowledgebasecomments as $knowledgebasecomment )
					{
						$knowledgebasecomment_data = explode( "|^Z|", $knowledgebasecomment );

						if( !$system -> decode( $knowledgebasecomment_data[ 4 ] ) )
						{
							$knowledgebasecomment_subject_array[ ] = $knowledgebase_question;
						}
						else
						{
							$knowledgebasecomment_subject_array[ ] = base64_decode( $knowledgebasecomment_data[ 4 ] );
						}

						$knowledgebasecomment_id_array[ ] = base64_decode( $knowledgebasecomment_data[ 0 ] );
						$knowledgebasecomment_authorid_array[ ] = base64_decode( $knowledgebasecomment_data[ 1 ] );
						$knowledgebasecomment_author_array[ ] = base64_decode( $knowledgebasecomment_data[ 2 ] );
						$knowledgebasecomment_icon_array[ ] = base64_decode( $knowledgebasecomment_data[ 3 ] );
						$knowledgebasecomment_rawtext_array[ ] = base64_decode( $knowledgebasecomment_data[ 5 ] );
						$knowledgebasecomment_text_array[ ] = base64_decode( $knowledgebasecomment_data[ 6 ] );
						$knowledgebasecomment_plonk_array[ ] = base64_decode( $knowledgebasecomment_data[ 7 ] );
						$knowledgebasecomment_signature_array[ ] = ( $preferences[ 'knowledgebase_forum_signatures' ] ) ? base64_decode( $knowledgebasecomment_data[ 8 ] ) : 0 ;
						$knowledgebasecomment_smilies_array[ ] = base64_decode( $knowledgebasecomment_data[ 9 ] );
						$knowledgebasecomment_bcode_array[ ] = base64_decode( $knowledgebasecomment_data[ 10 ] );
						$knowledgebasecomment_date_array[ ] = base64_decode( $knowledgebasecomment_data[ 11 ] );
						$knowledgebasecomment_edits_array[ ] = base64_decode( $knowledgebasecomment_data[ 12 ] );
						$knowledgebasecomment_lasteditauthor_array[ ] = base64_decode( $knowledgebasecomment_data[ 13 ] );
						$knowledgebasecomment_lasteditdate_array[ ] = base64_decode( $knowledgebasecomment_data[ 14 ] );
						$knowledgebasecomment_postip_array[ ] = base64_decode( $knowledgebasecomment_data[ 15 ] );
						$knowledgebasecomment_editip_array[ ] = base64_decode( $knowledgebasecomment_data[ 16 ] );
					}
				}
				else
				{
					if( $user[ 'user_status' ] == 3 and $preferences[ 'knowledgebase_allow_moderators' ] )
					{
						$moderator = 1;
					}

					if( $user[ 'user_status' ] == 2 or $moderator )
					{
						$insert[ 'knowledgebase_entry_comment_manage_header' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_manage_header_html' ], $main_templates[ 'knowledgebase_entry_comment_manage_header_php' ], $insert );
					}

					while( list( $knowledgebasecomment_id, $knowledgebasecomment_authorid, $knowledgebasecomment_author, $knowledgebasecomment_icon, $knowledgebasecomment_subject, $knowledgebasecomment_rawtext, $knowledgebasecomment_text, $knowledgebasecomment_plonk, $knowledgebasecomment_signature, $knowledgebasecomment_smilies, $knowledgebasecomment_bcode, $knowledgebasecomment_date, $knowledgebasecomment_edits, $knowledgebasecomment_lasteditauthor, $knowledgebasecomment_lasteditdate, $knowledgebasecomment_postip, $knowledgebasecomment_editip ) = $database -> dbrow( $query ) )
					{
						$knowledgebasecomment_id_array[ ] = $knowledgebasecomment_id;
						$knowledgebasecomment_authorid_array[ ] = $knowledgebasecomment_authorid;
						$knowledgebasecomment_author_array[ ] = $knowledgebasecomment_author;
						$knowledgebasecomment_icon_array[ ] = $knowledgebasecomment_icon;
						$knowledgebasecomment_subject_array[ ] = $knowledgebasecomment_subject;
						$knowledgebasecomment_rawtext_array[ ] = $knowledgebasecomment_rawtext;
						$knowledgebasecomment_text_array[ ] = $knowledgebasecomment_text;
						$knowledgebasecomment_plonk_array[ ] = $knowledgebasecomment_plonk;
						$knowledgebasecomment_signature_array[ ] = $knowledgebasecomment_signature;
						$knowledgebasecomment_smilies_array[ ] = $knowledgebasecomment_smilies;
						$knowledgebasecomment_bcode_array[ ] = $knowledgebasecomment_bcode;
						$knowledgebasecomment_date_array[ ] = $knowledgebasecomment_date;
						$knowledgebasecomment_edits_array[ ] = $knowledgebasecomment_edits;
						$knowledgebasecomment_lasteditauthor_array[ ] = $knowledgebasecomment_lasteditauthor;
						$knowledgebasecomment_lasteditdate_array[ ] = $knowledgebasecomment_lasteditdate;
						$knowledgebasecomment_postip_array[ ] = $knowledgebasecomment_postip;
						$knowledgebasecomment_editip_array[ ] = $knowledgebasecomment_editip;
					}
				}

				for( $c = 0; $c < count( $knowledgebasecomment_id_array ); $c++ )
				{
					$insert[ 'knowledgebasecomment_id' ] = intval( $knowledgebasecomment_id_array[ $c ] );
					$insert[ 'knowledgebasecomment_authorid' ] = intval( $knowledgebasecomment_authorid_array[ $c ] );
					$insert[ 'knowledgebasecomment_author' ] = htmlspecialchars( $knowledgebasecomment_author_array[ $c ], ENT_QUOTES, CT_ENCODING );
					$insert[ 'knowledgebasecomment_icon' ] = intval( $knowledgebasecomment_icon_array[ $c ] );
					$insert[ 'knowledgebasecomment_subject' ] = htmlspecialchars( $knowledgebasecomment_subject_array[ $c ], ENT_QUOTES, CT_ENCODING );
					$insert[ 'knowledgebasecomment_rawtext' ] = htmlspecialchars( $knowledgebasecomment_rawtext_array[ $c ], ENT_QUOTES, CT_ENCODING );
					$insert[ 'knowledgebasecomment_text' ] = $knowledgebasecomment_text_array[ $c ];
					$insert[ 'knowledgebasecomment_plonk' ] = intval( $knowledgebasecomment_plonk_array[ $c ] );
					$insert[ 'knowledgebasecomment_signature' ] = intval( $knowledgebasecomment_signature_array[ $c ] );
					$insert[ 'knowledgebasecomment_smilies' ] = intval( $knowledgebasecomment_smilies_array[ $c ] );
					$insert[ 'knowledgebasecomment_bcode' ] = intval( $knowledgebasecomment_bcode_array[ $c ] );
					$insert[ 'knowledgebasecomment_edits' ] = intval( $knowledgebasecomment_edits_array[ $c ] );
					$insert[ 'knowledgebasecomment_lasteditauthor' ] = htmlspecialchars( $knowledgebasecomment_lasteditauthor_array[ $c ], ENT_QUOTES, CT_ENCODING );
					$insert[ 'knowledgebasecomment_lasteditdate' ] = htmlspecialchars( $knowledgebasecomment_lasteditdate_array[ $c ], ENT_QUOTES, CT_ENCODING );
					$insert[ 'knowledgebasecomment_postip' ] = htmlspecialchars( $knowledgebasecomment_postip_array[ $c ], ENT_QUOTES, CT_ENCODING );
					$insert[ 'knowledgebasecomment_editip' ] = htmlspecialchars( $knowledgebasecomment_editip_array[ $c ], ENT_QUOTES, CT_ENCODING );
					$insert[ 'knowledgebasecomment_date' ] = $system -> convertdate( $knowledgebasecomment_date_array[ $c ], $preferences[ 'knowledgebase_dateformat' ], $preferences[ 'website_timezone' ] );

					if( isset( $knowledgebase_profile_array[ $insert[ 'knowledgebasecomment_authorid' ] ] ) )
					{
						$knowledgebasecomment_author = explode( "|^Z|", $knowledgebase_profile_array[ $insert[ 'knowledgebasecomment_authorid' ] ] );
						$knowledgebasecomment_author_regdate = explode( " ", $knowledgebasecomment_author[ 2 ] );
						$insert[ 'knowledgebasecomment_author' ] = $system -> decode( $knowledgebasecomment_author[ 0 ] );
						$insert[ 'knowledgebasecomment_author_status' ] = $knowledgebasecomment_author[ 1 ];
						$insert[ 'knowledgebasecomment_author_regdate' ] = $knowledgebasecomment_author_regdate[ 0 ];
						$insert[ 'knowledgebasecomment_author_posts' ] = $knowledgebasecomment_author[ 3 ];
						$insert[ 'knowledgebasecomment_author_birthday' ] = $knowledgebasecomment_author[ 4 ];
						$insert[ 'knowledgebasecomment_author_location' ] = $system -> decode( $knowledgebasecomment_author[ 5 ] );
						$insert[ 'knowledgebasecomment_author_avatar' ] = $knowledgebasecomment_author[ 6 ];
						$insert[ 'knowledgebasecomment_author_signature' ] = ( !$preferences[ 'knowledgebase_forum_signatures' ] and !preg_match( "/Contentteller/i", $preferences[ 'website_uwrapper_product' ] ) ) ? "" : $system -> decode( $knowledgebasecomment_author[ 7 ] );
						$insert[ 'knowledgebasecomment_author_question' ] = $system -> decode( $knowledgebasecomment_author[ 8 ] );
						$insert[ 'knowledgebasecomment_author_regip' ] = $knowledgebasecomment_author[ 9 ];
						$insert[ 'knowledgebasecomment_author_usertitle' ] = "";

						if ($insert[ 'knowledgebasecomment_author_title' ])
						{
							$insert[ 'knowledgebasecomment_author_usertitle' ] = $insert[ 'knowledgebasecomment_author_title' ];
						}
						else
						{
							for( $i = 0; $i < count( $knowledgebase_usertitle_question_array ); $i++ )
							{
								if( $knowledgebasecomment_author[ 3 ] >= $knowledgebase_usertitle_posts_array[ $i ] )
								{
									$insert[ 'knowledgebasecomment_author_usertitle' ] = $knowledgebase_usertitle_question_array[ $i ];
								}
							}
						}

						$insert[ 'knowledgebasecomment_author_postsline' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_userposts_html' ], $main_templates[ 'knowledgebase_entry_comment_userposts_php' ], $insert );

						if( $insert[ 'knowledgebasecomment_author_regdate' ] )
						{
							$insert[ 'knowledgebasecomment_author_regdateline' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_userregdate_html' ], $main_templates[ 'knowledgebase_entry_comment_userregdate_php' ], $insert );
						}
						else
						{
							$insert[ 'knowledgebasecomment_author_locationline' ] = "";
						}

						if( $insert[ 'knowledgebasecomment_author_location' ] )
						{
							$insert[ 'knowledgebasecomment_author_locationline' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_userlocation_html' ], $main_templates[ 'knowledgebase_entry_comment_userlocation_php' ], $insert );
						}
						else
						{
							$insert[ 'knowledgebasecomment_author_locationline' ] = "";
						}

						if( $knowledgebasecomment_author[ 1 ] == 1 or $knowledgebasecomment_author[ 1 ] == 4 )
						{
							$insert[ 'knowledgebasecomment_author_titleline' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_usertitle_html' ], $main_templates[ 'knowledgebase_entry_comment_usertitle_php' ], $insert );
						}
						elseif( $knowledgebasecomment_author[ 1 ] == 2 )
						{
							$insert[ 'knowledgebasecomment_author_titleline' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_usertitle_admin_html' ], $main_templates[ 'knowledgebase_entry_comment_usertitle_admin_php' ], $insert );
						}
						elseif( $knowledgebasecomment_author[ 1 ] == 3 )
						{
							$insert[ 'knowledgebasecomment_author_titleline' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_usertitle_moderator_html' ], $main_templates[ 'knowledgebase_entry_comment_usertitle_moderator_php' ], $insert );
						}
						elseif( $knowledgebasecomment_author[ 1 ] == 5 )
						{
							$insert[ 'knowledgebasecomment_author_titleline' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_usertitle_banned_html' ], $main_templates[ 'knowledgebase_entry_comment_usertitle_banned_php' ], $insert );
						}
						elseif( $knowledgebasecomment_author[ 1 ] == 6 )
						{
							$insert[ 'knowledgebasecomment_author_titleline' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_usertitle_subscriber_html' ], $main_templates[ 'knowledgebase_entry_usertitle_subscriber_php' ], $insert );
						}
					}
					else
					{
						$insert[ 'knowledgebasecomment_author_status' ] = "";
						$insert[ 'knowledgebasecomment_author_regdate' ] = "";
						$insert[ 'knowledgebasecomment_author_posts' ] = "";
						$insert[ 'knowledgebasecomment_author_birthday' ] = "";
						$insert[ 'knowledgebasecomment_author_location' ] = "";
						$insert[ 'knowledgebasecomment_author_avatar' ] = "";
						$insert[ 'knowledgebasecomment_author_signature' ] = "";
						$insert[ 'knowledgebasecomment_author_title' ] = "";
						$insert[ 'knowledgebasecomment_author_regip' ] = "";
						$insert[ 'knowledgebasecomment_author_titleline' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_usertitle_anon_html' ], $main_templates[ 'knowledgebase_entry_comment_usertitle_anon_php' ], $insert );
						$insert[ 'knowledgebasecomment_author_postsline' ] = "";
						$insert[ 'knowledgebasecomment_author_regdateline' ] = "";
						$insert[ 'knowledgebasecomment_author_locationline' ] = "";
					}

					if( $insert[ 'knowledgebasecomment_author_avatar' ] and $user[ 'user_showavatars' ] )
					{
						$insert[ 'knowledgebasecomment_author_avatarline' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_avatar_html' ], $main_templates[ 'knowledgebase_entry_comment_avatar_php' ], $insert );
					}
					else
					{
						$insert[ 'knowledgebasecomment_author_avatarline' ] = "";
					}

					if( $insert[ 'knowledgebasecomment_author_signature' ] and $user[ 'user_showsignatures' ] and $preferences[ 'knowledgebase_show_signature' ] )
					{
						$insert[ 'knowledgebasecomment_author_signature' ] = $system -> smilies( $system -> code( $insert[ 'knowledgebasecomment_author_signature' ] ) );
						$insert[ 'knowledgebasecomment_author_signatureline' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_signature_html' ], $main_templates[ 'knowledgebase_entry_comment_signature_php' ], $insert );
					}
					else
					{
						$insert[ 'knowledgebasecomment_author_signatureline' ] = "";
					}

					if( $user[ 'user_status' ] and $insert[ 'knowledgebasecomment_authorid' ] )
					{
						$insert[ 'knowledgebasecomment_authorline' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_profile_html' ], $main_templates[ 'knowledgebase_entry_comment_profile_php' ], $insert );
					}
					else
					{
						$insert[ 'knowledgebasecomment_authorline' ] = $insert[ 'knowledgebasecomment_author' ];
					}

					if( $preferences[ 'knowledgebase_allow_msgicons' ] and isset( $knowledgebase_messageicons[ $insert[ 'knowledgebasecomment_icon' ] ] ) )
					{
						$insert[ 'knowledgebasecomment_messageicon' ] = $knowledgebase_messageicons[ $insert[ 'knowledgebasecomment_icon' ] ];
						$insert[ 'knowledgebasecomment_messageicon' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_messageicon_html' ], $main_templates[ 'knowledgebase_entry_comment_messageicon_php' ], $insert );
					}
					else
					{
						$insert[ 'knowledgebasecomment_messageicon' ] = "";
					}

					if( $user[ 'user_status' ] and !$insert[ 'knowledgebase_thread' ] )
					{
						$insert[ 'knowledgebasecomment_rawtext' ] = $system -> fixbreaks( addslashes( $insert[ 'knowledgebasecomment_rawtext' ] ) );

						if( $user[ 'user_status' ] == 2 or $moderator )
						{
							$insert[ 'knowledgebasecomment_options' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_options_admin_html' ], $main_templates[ 'knowledgebase_entry_comment_options_admin_php' ], $insert );
						}
						else
						{
							if( $user[ 'user_name' ] == $insert[ 'knowledgebasecomment_author' ] )
							{
								$insert[ 'knowledgebasecomment_options_edit' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_options_edit_html' ], $main_templates[ 'knowledgebase_entry_comment_options_edit_php' ], $insert );
							}
							else
							{
								$insert[ 'knowledgebasecomment_options_edit' ] = "";
							}

							$insert[ 'knowledgebasecomment_options' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_options_html' ], $main_templates[ 'knowledgebase_entry_comment_options_php' ], $insert );
						}
					}
					else
					{
						$insert[ 'knowledgebasecomment_options' ] = "";
					}

					if( ( !$insert[ 'knowledgebasecomment_plonk' ] ) or( $user[ 'user_status' ] == 4 and $insert[ 'knowledgebasecomment_plonk' ] ) )
					{
						$insert[ 'knowledgebase_entry_comment' ] .= $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_html' ], $main_templates[ 'knowledgebase_entry_comment_php' ], $insert );
					}
					else
					{
						$insert[ 'knowledgebase_entry_comment' ] .= $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_plonk_html' ], $main_templates[ 'knowledgebase_entry_comment_plonk_php' ], $insert );
					}
				}

				if( ( $user[ 'user_status' ] == 2 or $moderator ) and( !$insert[ 'knowledgebase_thread' ] ) )
				{
					$insert[ 'knowledgebase_entry_comment_manage_footer' ] .= $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_manage_footer_html' ], $main_templates[ 'knowledgebase_entry_comment_manage_footer_php' ], $insert );
				}
			}
		}

		if( $insert[ 'knowledgebase_thread' ] )
		{
			$insert[ 'knowledgebase_threadlink' ] = $uwrapper -> getthreadlink( $insert[ 'knowledgebase_thread' ] );
			$insert[ 'knowledgebase_entry_comment_form' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_form_external_html' ], $main_templates[ 'knowledgebase_entry_comment_form_external_php' ], $insert );
		}
		else
		{
			$insert[ 'input_anon' ] = "";
			$insert[ 'input_subject' ] = "";
			$insert[ 'input_message' ] = "";

			if( $preferences[ 'knowledgebase_allow_unregcomments' ] and !$user[ 'user_status' ] )
			{
				$insert[ 'knowledgebase_anon' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_form_anon_html' ], $main_templates[ 'knowledgebase_entry_comment_form_anon_php' ], $insert );
			}
			else
			{
				$insert[ 'knowledgebase_anon' ] = "";
			}

			if( $preferences[ 'knowledgebase_allow_msgicons' ] )
			{
				$query = $database -> dbquery( "SELECT messageicon_id, messageicon_name, messageicon_image FROM " . DB_PREFIX . "esselbach_ct_messageicons WHERE messageicon_active = '1' ORDER BY messageicon_position" );
				$messageicon_row = 0;
				$insert[ 'knowledgebase_iconrow' ] = "";

				while( list( $insert[ 'messageicon_id' ], $insert[ 'messageicon_name' ], $insert[ 'messageicon_image' ] ) = $database -> dbrow( $query ) )
				{
					$insert[ 'messageicon_name' ] = htmlspecialchars( $insert[ 'messageicon_name' ], ENT_QUOTES, CT_ENCODING );
					$insert[ 'messageicon_image' ] = htmlspecialchars( $insert[ 'messageicon_image' ], ENT_QUOTES, CT_ENCODING );

					if( !$messageicon_row )
					{
						$insert[ 'messageicon_checked' ] = "checked=\"checked\"";
					}
					else
					{
						$insert[ 'messageicon_checked' ] = "";
					}

					$messageicon_row++;

					if( $messageicon_row > $preferences[ 'knowledgebase_max_msgicons' ] )
					{
						$insert[ 'messageicon_break' ] = "<br />";
						$messageicon_row = 1;
					}
					else
					{
						$insert[ 'messageicon_break' ] = "";
					}

					$insert[ 'knowledgebase_iconrow' ] .= $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_form_iconrow_html' ], $main_templates[ 'knowledgebase_entry_comment_form_iconrow_php' ], $insert );
				}
			}

			if( $insert[ 'knowledgebase_iconrow' ] )
			{
				$insert[ 'knowledgebase_icon' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_form_icon_html' ], $main_templates[ 'knowledgebase_entry_comment_form_icon_php' ], $insert );
			}
			else
			{
				$insert[ 'knowledgebase_icon' ] = "";
			}

			if( ( $user[ 'user_status' ] or $preferences[ 'knowledgebase_allow_unregcomments' ] ) and $insert[ 'knowledgebase_allowcomments' ] )
			{
				if( $user[ 'user_status' ] )
				{
					$input_signature = $uwrapper -> signature( $input_author );
					( $input_signature ) ? $insert[ 'input_signature_checked' ] = "checked=\"checked\"" : $insert[ 'input_signature_checked' ] = "" ;
					$insert[ 'knowledgebase_signature' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_form_signature_html' ], $main_templates[ 'knowledgebase_entry_comment_form_signature_php' ], $insert );
				}
				else
				{
					$input_signature = 0;
					$insert[ 'knowledgebase_signature' ] = "";
				}

				$insert[ 'input_smilies_checked' ] = "";
				$insert[ 'input_bcode_checked' ] = "";

				if( $preferences[ 'knowledgebase_securitycode' ] )
				{
					if( ( $preferences[ 'website_recaptcha' ] ) and ( $preferences[ 'website_recaptcha_public_key' ] ) and ( $preferences[ 'website_recaptcha_private_key' ] ) and function_exists( "curl_exec" ) )
					{
						$insert[ 'website_recaptcha_public_key' ] = $preferences[ 'website_recaptcha_public_key' ];
						$insert[ 'knowledgebase_securitycode' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_form_recaptcha_html' ], $main_templates[ 'knowledgebase_entry_comment_form_recaptcha_php' ], $insert );
					}
					elseif( function_exists( "imagestring" ) and !$user[ 'user_nocookie' ] )
					{
						$insert[ 'input_securitycode' ] = "";
						if( !isset( $_SESSION[ 'knowledgebase_security_code' ] ) )
						{
							session_start();
							$_SESSION[ 'knowledgebase_security_code' ] = substr( md5( $system -> dorand() ), 14, 8 );
						}
						$insert[ 'knowledgebase_securitycode' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_form_securitycode_html' ], $main_templates[ 'knowledgebase_entry_comment_form_securitycode_php' ], $insert );
					}
				}
				else
				{
					$insert[ 'knowledgebase_securitycode' ] = "";
				}

				if ( $preferences[ 'knowledgebase_comments_wysiwyg' ] )
				{
					$insert[ 'knowledgebase_entry_comment_form' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_form_wysiwyg_html' ], $main_templates[ 'knowledgebase_entry_comment_form_wysiwyg_php' ], $insert );
				}
				else
				{
					$insert[ 'knowledgebase_entry_comment_form' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_comment_form_html' ], $main_templates[ 'knowledgebase_entry_comment_form_php' ], $insert );
				}
			}
			else
			{
				$insert[ 'knowledgebase_entry_comment_form' ] = "";
			}
		}
	}
	else
	{
		echo $templates -> exectemplate( $main_templates[ 'knowledgebase_error_noentry_html' ], $main_templates[ 'knowledgebase_error_noentry_php' ], $insert );
	}

	if( $preferences[ 'knowledgebase_navigation' ] )
	{
		if( $knowledgebase_entry )
		{
			$insert[ 'knowledgebase_entry_footer' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_footer_html' ], $main_templates[ 'knowledgebase_entry_footer_php' ], $insert );
		}
		else
		{
			echo $templates -> exectemplate( $main_templates[ 'knowledgebase_footer_html' ], $main_templates[ 'knowledgebase_footer_php' ], $insert );
		}
	}

	if( $knowledgebase_entry )
	{
		echo $templates -> exectemplate( $main_templates[ 'knowledgebase_layout_entry_html' ], $main_templates[ 'knowledgebase_layout_entry_php' ], $insert );
	}

	if( $preferences[ 'knowledgebase_alt_site_header' ] )
	{
		echo $templates -> exectemplate( $main_templates[ 'site_footer_alt_html' ], $main_templates[ 'site_footer_alt_php' ], $insert );
	}
	else
	{
		echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
	}
}
?>